function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

const { sendError, send } = require('micro');
const url = require('url');

module.exports = function route(routes) {
  const availablePaths = Object.keys(routes);
  return routes['*']((() => {
    var _ref = _asyncToGenerator(function* (req, res) {
      const { pathname } = url.parse(req.url);
      if (availablePaths.indexOf(pathname) === -1) {
        return send(res, 404, `${req.method} ${req.url} Not Found`);
      }
      if (!routes[pathname][req.method]) {
        return send(res, 405, `Method Not Allowed`);
      }
      try {
        return yield routes[pathname][req.method](req, res);
      } catch (err) {
        console.log(err.stack);
        if (err.statusCode === 400) {
          sendError(req, res, err);
          return;
        }
        send(res, 500, 'Internal Server Error');
      }
    });

    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  })());
};